lxc.sh 15 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507
  1. #!/usr/bin/env bash
  2. # -*- coding: utf-8; mode: sh indent-tabs-mode: nil -*-
  3. # SPDX-License-Identifier: AGPL-3.0-or-later
  4. # shellcheck source=utils/lib.sh
  5. source "$(dirname "${BASH_SOURCE[0]}")/lib.sh"
  6. source_dot_config
  7. # load environment of the LXC suite
  8. LXC_ENV="${LXC_ENV:-${REPO_ROOT}/utils/lxc-searx.env}"
  9. source "$LXC_ENV"
  10. lxc_set_suite_env
  11. # ----------------------------------------------------------------------------
  12. # config
  13. # ----------------------------------------------------------------------------
  14. #
  15. # read also:
  16. # - https://lxd.readthedocs.io/en/latest/
  17. LXC_HOST_PREFIX="${LXC_HOST_PREFIX:-test}"
  18. # where all folders from HOST are mounted
  19. LXC_SHARE_FOLDER="/share"
  20. LXC_REPO_ROOT="${LXC_SHARE_FOLDER}/$(basename "${REPO_ROOT}")"
  21. ubu1604_boilerplate="
  22. export DEBIAN_FRONTEND=noninteractive
  23. apt-get update -y
  24. apt-get upgrade -y
  25. apt-get install -y git curl wget
  26. "
  27. ubu1804_boilerplate="$ubu1604_boilerplate"
  28. ubu1904_boilerplate="$ubu1804_boilerplate"
  29. ubu1910_boilerplate="$ubu1904_boilerplate"
  30. # shellcheck disable=SC2034
  31. ubu2004_boilerplate="
  32. $ubu1910_boilerplate
  33. echo 'Set disable_coredump false' >> /etc/sudo.conf
  34. "
  35. # shellcheck disable=SC2034
  36. archlinux_boilerplate="
  37. pacman -Syu --noconfirm
  38. pacman -S --noconfirm git curl wget sudo
  39. echo 'Set disable_coredump false' >> /etc/sudo.conf
  40. "
  41. # shellcheck disable=SC2034
  42. fedora31_boilerplate="
  43. dnf update -y
  44. dnf install -y git curl wget hostname
  45. echo 'Set disable_coredump false' >> /etc/sudo.conf
  46. "
  47. REMOTE_IMAGES=()
  48. CONTAINERS=()
  49. LOCAL_IMAGES=()
  50. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  51. REMOTE_IMAGES=("${REMOTE_IMAGES[@]}" "${LXC_SUITE[i]}")
  52. CONTAINERS=("${CONTAINERS[@]}" "${LXC_HOST_PREFIX}-${LXC_SUITE[i+1]}")
  53. LOCAL_IMAGES=("${LOCAL_IMAGES[@]}" "${LXC_SUITE[i+1]}")
  54. done
  55. HOST_USER="${SUDO_USER:-$USER}"
  56. HOST_USER_ID=$(id -u "${HOST_USER}")
  57. HOST_GROUP_ID=$(id -g "${HOST_USER}")
  58. # ----------------------------------------------------------------------------
  59. usage() {
  60. # ----------------------------------------------------------------------------
  61. _cmd="$(basename "$0")"
  62. cat <<EOF
  63. usage::
  64. $_cmd build [containers]
  65. $_cmd copy [images]
  66. $_cmd remove [containers|<name>|images|subordinate]
  67. $_cmd add [subordinate]
  68. $_cmd [start|stop] [containers|<name>]
  69. $_cmd show [info|config|suite|images]
  70. $_cmd cmd [--|<name>] ...
  71. $_cmd install [suite]
  72. build
  73. :containers: build & launch all LXC containers of the suite
  74. copy:
  75. :images: copy remote images of the suite into local storage
  76. remove
  77. :containers: delete all 'containers' or only <container-name>
  78. :images: delete local images of the suite
  79. add / remove
  80. :subordinate: LXD permission to map ${HOST_USER}'s user/group id through
  81. start/stop
  82. :containers: start/stop all 'containers' from the suite
  83. :<name>: start/stop conatiner <name> from suite
  84. show
  85. :info: show info of all the containers from LXC suite
  86. :config: show config of all the containers from the LXC suite
  87. :suite: show services of all the containers from the LXC suite
  88. :images: show information of local images
  89. cmd
  90. -- run command ... in all containers of the LXC suite
  91. :<name>: run command ... in container <name>
  92. install
  93. :suite: install LXC suite, includes morty & filtron
  94. Images of the LXC suite:
  95. $(echo " ${LOCAL_IMAGES[*]}" | $FMT)
  96. Containers of the LXC suite:
  97. $(echo " ${CONTAINERS[*]}" | $FMT)
  98. EOF
  99. [ -n "${1+x}" ] && err_msg "$1"
  100. }
  101. lxd_info() {
  102. cat <<EOF
  103. LXD is needed, to install run::
  104. snap install lxd
  105. lxd init --auto
  106. EOF
  107. }
  108. main() {
  109. local exit_val
  110. local _usage="unknown or missing $1 command $2"
  111. # don't check prerequisite when in recursion
  112. if [[ ! $1 == __* ]]; then
  113. ! required_commands lxc && lxd_info && exit 42
  114. [[ -z $LXC_SUITE ]] && err_msg "missing LXC_SUITE" && exit 42
  115. fi
  116. case $1 in
  117. --source-only) ;;
  118. -h|--help) usage; exit 0;;
  119. build)
  120. sudo_or_exit
  121. case $2 in
  122. ''|containers) build_instances ;;
  123. *) usage "$_usage"; exit 42;;
  124. esac
  125. ;;
  126. copy)
  127. case $2 in
  128. ''|images) lxc_copy_images_localy;;
  129. *) usage "$_usage"; exit 42;;
  130. esac
  131. ;;
  132. remove)
  133. sudo_or_exit
  134. case $2 in
  135. ''|containers) remove_instances ;;
  136. images) lxc_delete_images_localy ;;
  137. subordinate) echo; del_subordinate_ids ;;
  138. ${LXC_HOST_PREFIX}-*)
  139. if ask_yn "Do you really want to delete conatiner $2"; then
  140. lxc_delete_container "$2"
  141. fi
  142. ;;
  143. *) usage "unknown (or mising) container <name> $2"; exit 42;;
  144. esac
  145. ;;
  146. add)
  147. sudo_or_exit
  148. case $2 in
  149. subordinate) echo; add_subordinate_ids ;;
  150. *) usage "$_usage"; exit 42;;
  151. esac
  152. ;;
  153. start|stop)
  154. sudo_or_exit
  155. case $2 in
  156. ''|containers) lxc_cmd "$1" ;;
  157. ${LXC_HOST_PREFIX}-*)
  158. info_msg "lxc $1 $2"
  159. lxc "$1" "$2" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  160. ;;
  161. *) usage "ukknown or missing container <name> $2"; exit 42;;
  162. esac
  163. ;;
  164. show)
  165. sudo_or_exit
  166. case $2 in
  167. suite) show_suite ;;
  168. images) show_images ;;
  169. config)
  170. rst_title "container configurations"
  171. echo
  172. lxc list "$LXC_HOST_PREFIX-"
  173. echo
  174. lxc_cmd config show
  175. ;;
  176. info)
  177. rst_title "container info"
  178. echo
  179. lxc_cmd info
  180. ;;
  181. *) usage "$_usage"; exit 42;;
  182. esac
  183. ;;
  184. __show)
  185. case $2 in
  186. suite) lxc_suite_info ;;
  187. esac
  188. ;;
  189. cmd)
  190. sudo_or_exit
  191. shift
  192. case $1 in
  193. --)
  194. shift
  195. for name in "${CONTAINERS[@]}"; do
  196. lxc_exec_cmd "${name}" "$@"
  197. done
  198. ;;
  199. ${LXC_HOST_PREFIX}-*)
  200. local name=$1
  201. shift
  202. lxc_exec_cmd "${name}" "$@"
  203. ;;
  204. *) usage "unknown <name>: $1"; exit 42
  205. ;;
  206. esac
  207. ;;
  208. install)
  209. sudo_or_exit
  210. case $2 in
  211. suite) install_suite ;;
  212. *) usage "$_usage"; exit 42 ;;
  213. esac
  214. ;;
  215. __install)
  216. case $2 in
  217. suite) lxc_suite_install ;;
  218. esac
  219. ;;
  220. doc)
  221. echo
  222. echo ".. generic utils/lxc.sh documentation"
  223. ;;
  224. -*) usage "unknown option $1"; exit 42;;
  225. *) usage "unknown or missing command $1"; exit 42;;
  226. esac
  227. }
  228. build_instances() {
  229. rst_title "Build LXC instances"
  230. echo
  231. add_subordinate_ids
  232. lxc_copy_images_localy
  233. echo
  234. rst_title "build containers" section
  235. echo
  236. lxc_init_containers
  237. lxc_config_containers
  238. lxc_boilerplate_containers
  239. echo
  240. lxc list "$LXC_HOST_PREFIX"
  241. }
  242. remove_instances() {
  243. rst_title "Remove LXC instances"
  244. rst_para "existing containers matching ${_BGreen}$LXC_HOST_PREFIX-*${_creset}"
  245. echo
  246. lxc list "$LXC_HOST_PREFIX-"
  247. echo -en "\\n${_BRed}LXC containers to delete::${_creset}\\n\\n ${CONTAINERS[*]}\\n" | $FMT
  248. if ask_yn "Do you really want to delete these conatiners"; then
  249. for i in "${CONTAINERS[@]}"; do
  250. lxc_delete_container "$i"
  251. done
  252. fi
  253. echo
  254. lxc list "$LXC_HOST_PREFIX-"
  255. }
  256. # images
  257. # ------
  258. lxc_copy_images_localy() {
  259. rst_title "copy images" section
  260. echo
  261. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  262. if lxc_image_exists "local:${LXC_SUITE[i+1]}"; then
  263. info_msg "image ${LXC_SUITE[i]} already copied --> ${LXC_SUITE[i+1]}"
  264. else
  265. info_msg "copy image locally ${LXC_SUITE[i]} --> ${LXC_SUITE[i+1]}"
  266. lxc image copy "${LXC_SUITE[i]}" local: \
  267. --alias "${LXC_SUITE[i+1]}" | prefix_stdout
  268. fi
  269. done
  270. # lxc image list local: && wait_key
  271. }
  272. lxc_delete_images_localy() {
  273. rst_title "Delete LXC images"
  274. rst_para "local existing images"
  275. echo
  276. lxc image list local:
  277. echo -en "\\n${_BRed}LXC images to delete::${_creset}\\n\\n ${LOCAL_IMAGES[*]}\\n"
  278. if ask_yn "Do you really want to delete these images"; then
  279. for i in "${LOCAL_IMAGES[@]}"; do
  280. lxc_delete_local_image "$i"
  281. done
  282. fi
  283. echo
  284. lxc image list local:
  285. }
  286. show_images(){
  287. rst_title "local images"
  288. echo
  289. lxc image list local:
  290. echo -en "\\n${_Green}LXC suite images::${_creset}\\n\\n ${LOCAL_IMAGES[*]}\\n"
  291. wait_key
  292. for i in "${LOCAL_IMAGES[@]}"; do
  293. if lxc_image_exists "$i"; then
  294. info_msg "lxc image info ${_BBlue}${i}${_creset}"
  295. lxc image info "$i" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  296. else
  297. warn_msg "image ${_BBlue}$i${_creset} does not yet exists"
  298. fi
  299. done
  300. }
  301. # container
  302. # ---------
  303. show_suite(){
  304. rst_title "LXC suite ($LXC_HOST_PREFIX-*)"
  305. echo
  306. lxc list "$LXC_HOST_PREFIX-"
  307. echo
  308. for i in "${CONTAINERS[@]}"; do
  309. if ! lxc_exists "$i"; then
  310. warn_msg "container ${_BBlue}$i${_creset} does not yet exists"
  311. else
  312. lxc exec -t "${i}" -- "${LXC_REPO_ROOT}/utils/lxc.sh" __show suite \
  313. | prefix_stdout "[${_BBlue}${i}${_creset}] "
  314. fi
  315. done
  316. }
  317. install_suite() {
  318. for i in "${CONTAINERS[@]}"; do
  319. if ! lxc_exists "$i"; then
  320. warn_msg "container ${_BBlue}$i${_creset} does not yet exists"
  321. else
  322. info_msg "[${_BBlue}${i}${_creset}] ${_BGreen}${LXC_REPO_ROOT}/utils/lxc.sh install suite${_creset}"
  323. lxc exec -t "${i}" -- "${LXC_REPO_ROOT}/utils/lxc.sh" __install suite \
  324. | prefix_stdout "[${_BBlue}${i}${_creset}] "
  325. fi
  326. done
  327. }
  328. lxc_cmd() {
  329. for i in "${CONTAINERS[@]}"; do
  330. if ! lxc_exists "$i"; then
  331. warn_msg "container ${_BBlue}$i${_creset} does not yet exists"
  332. else
  333. info_msg "lxc $* $i"
  334. lxc "$@" "$i" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  335. echo
  336. fi
  337. done
  338. }
  339. lxc_exec_cmd() {
  340. local name="$1"
  341. shift
  342. exit_val=
  343. info_msg "[${_BBlue}${name}${_creset}] ${_BGreen}${*}${_creset}"
  344. lxc exec "${name}" -- "$@"
  345. exit_val=$?
  346. if [[ $exit_val -ne 0 ]]; then
  347. warn_msg "[${_BBlue}${i}${_creset}] exit code (${_BRed}${exit_val}${_creset}) from ${_BGreen}${*}${_creset}"
  348. else
  349. info_msg "[${_BBlue}${i}${_creset}] exit code (${exit_val}) from ${_BGreen}${*}${_creset}"
  350. fi
  351. echo
  352. }
  353. lxc_init_containers() {
  354. local image_name
  355. local container_name
  356. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  357. image_name="${LXC_SUITE[i+1]}"
  358. container_name="${LXC_HOST_PREFIX}-${image_name}"
  359. if lxc info "${container_name}" &>/dev/null; then
  360. info_msg "container '${container_name}' already exists"
  361. else
  362. info_msg "create conatiner instance: ${container_name}"
  363. lxc init "local:${image_name}" "${container_name}"
  364. fi
  365. done
  366. }
  367. lxc_config_containers() {
  368. for i in "${CONTAINERS[@]}"; do
  369. info_msg "[${_BBlue}${i}${_creset}] configure container ..."
  370. info_msg "[${_BBlue}${i}${_creset}] map uid/gid from host to container"
  371. # https://lxd.readthedocs.io/en/latest/userns-idmap/#custom-idmaps
  372. echo -e -n "uid $HOST_USER_ID 1000\\ngid $HOST_GROUP_ID 1000"\
  373. | lxc config set "$i" raw.idmap -
  374. info_msg "[${_BBlue}${i}${_creset}] share ${REPO_ROOT} (repo_share) from HOST into container"
  375. # https://lxd.readthedocs.io/en/latest/instances/#type-disk
  376. lxc config device add "$i" repo_share disk \
  377. source="${REPO_ROOT}" \
  378. path="${LXC_REPO_ROOT}" &>/dev/null
  379. # lxc config show "$i" && wait_key
  380. done
  381. }
  382. lxc_boilerplate_containers() {
  383. local image_name
  384. local container_name
  385. local boilerplate_script
  386. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  387. image_name="${LXC_SUITE[i+1]}"
  388. container_name="${LXC_HOST_PREFIX}-${image_name}"
  389. boilerplate_script="${image_name}_boilerplate"
  390. boilerplate_script="${!boilerplate_script}"
  391. info_msg "[${_BBlue}${container_name}${_creset}] install boilerplate"
  392. if lxc start -q "${container_name}" &>/dev/null; then
  393. sleep 5 # guest needs some time to come up and get an IP
  394. fi
  395. if [[ -n "${boilerplate_script}" ]]; then
  396. echo "${boilerplate_script}" \
  397. | lxc exec "${container_name}" -- bash \
  398. | prefix_stdout "[${_BBlue}${container_name}${_creset}] "
  399. else
  400. err_msg "[${_BBlue}${container_name}${_creset}] no boilerplate for image '${image_name}'"
  401. fi
  402. done
  403. }
  404. # subordinates
  405. # ------------
  406. #
  407. # see man: subgid(5), subuid(5), https://lxd.readthedocs.io/en/latest/userns-idmap
  408. #
  409. # E.g. in the HOST you have uid=1001(user) and/or gid=1001(user) ::
  410. #
  411. # root:1001:1
  412. #
  413. # in the CONTAINER::
  414. #
  415. # config:
  416. # raw.idmap: |
  417. # uid 1001 1000
  418. # gid 1001 1000
  419. add_subordinate_ids() {
  420. if grep "root:${HOST_USER_ID}:1" /etc/subuid -qs; then
  421. info_msg "lxd already has permission to map ${HOST_USER_ID}'s user/group id through"
  422. else
  423. info_msg "add lxd permission to map ${HOST_USER_ID}'s user/group id through"
  424. usermod --add-subuids "${HOST_USER_ID}-${HOST_USER_ID}" \
  425. --add-subgids "${HOST_GROUP_ID}-${HOST_GROUP_ID}" root
  426. fi
  427. }
  428. del_subordinate_ids() {
  429. local out
  430. local exit_val
  431. if grep "root:${HOST_USER_ID}:1" /etc/subuid -qs; then
  432. # TODO: root user is always in use by process 1, how can we remove subordinates?
  433. info_msg "remove lxd permission to map ${HOST_USER_ID}'s user/group id through"
  434. out=$(usermod --del-subuids "${HOST_USER_ID}-${HOST_USER_ID}" --del-subgids "${HOST_GROUP_ID}-${HOST_GROUP_ID}" root 2>&1)
  435. exit_val=$?
  436. if [ $exit_val -ne 0 ]; then
  437. err_msg "$out"
  438. fi
  439. else
  440. info_msg "lxd does not have permission to map ${HOST_USER_ID}'s user/group id through"
  441. fi
  442. }
  443. # ----------------------------------------------------------------------------
  444. main "$@"
  445. # ----------------------------------------------------------------------------